/*******************************************************************************
 *
 * MIT License
 *
 * Copyright (C) 2019-2022 Advanced Micro Devices, Inc. All rights reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 *
 *******************************************************************************/

#pragma once

#include <Tensile/ContractionProblem.hpp>
#include <Tensile/ContractionSolution.hpp>
#include <Tensile/ExactLogicLibrary.hpp>
#include <Tensile/GranularitySelectionLibrary.hpp>
#include <Tensile/MapLibrary.hpp>
#include <Tensile/MasterSolutionLibrary.hpp>
#include <Tensile/MatchingLibrary.hpp>
#include <Tensile/SingleSolutionLibrary.hpp>
#include <Tensile/SolutionLibrary.hpp>

namespace Tensile
{
    using ContractionLibrary       = SolutionLibrary<ContractionProblem>;
    using MasterContractionLibrary = MasterSolutionLibrary<ContractionProblem, ContractionSolution>;
    using SingleContractionLibrary = SingleSolutionLibrary<ContractionProblem, ContractionSolution>;
    using ContractionHardwareSelectionLibrary
        = HardwareSelectionLibrary<ContractionProblem, ContractionSolution>;
    using ContractionProblemSelectionLibrary
        = ProblemSelectionLibrary<ContractionProblem, ContractionSolution>;
    using ContractionProblemMatchingLibrary
        = ProblemMatchingLibrary<ContractionProblem, ContractionSolution>;
    using ContractionProblemMapLibrary = ProblemMapLibrary<ContractionProblem, ContractionSolution>;
    using ContractionProblemPredicate  = ProblemPredicate<ContractionProblem>;
    using ContractionGranularitySelectionLibrary
        = GranularitySelectionLibrary<ContractionProblem, ContractionSolution>;
} // namespace Tensile
